//
// Watshit v1.02 By Mikael Klasson
// fluff@geocities.com
// http://mklasson.cjb.net
//
#define WIN32_LEAN_AND_MEAN

#include <windows.h>
#include <windowsx.h>
#include <stdio.h>
#include <time.h>
#include <direct.h>
#include <stdlib.h>
#include "resource.h"
#include <commdlg.h>
#include <commctrl.h>
#include <math.h>
#include <winperf.h>

#define CFGLEFT_ERR		-42
#define CFGTOP_ERR		-42
#define ID_TIMER_UPDATE		1
#define	ID_TIMER_ABOUT		3
#define	ID_TIMER_SCROLL		4
#define	ID_TIMER_FIRST		39000
#define	ID_TIMER_LAST		39998
#define	ID_TIMERDLG		39999
#define	ID_H			39000
#define	ID_M			39001
#define	ID_S			39002
#define	ID_HTEXT		39003
#define	ID_MTEXT		39004
#define	ID_STEXT		39005
#define	ID_ENTER		39006
#define	ID_NAME			39007
#define	ID_MSG			39008
#define	ID_SAVE			39009
#define	ID_NAMETEXT		39010
#define	ID_MSGTEXT		39011
#define	ID_SAVETEXT		39012

#define	TIME_TIMER_ABOUT	1000 / 30

#define	DEGINC			2

LRESULT CALLBACK	WindowProc( HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam );
LRESULT CALLBACK	AboutDlgProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
void			ReleaseTimer( void );
void			ReadIniFile( void );
__int64			ReadIniVal( char *pszIniFile, char *pszKey, __int64 iDefault );
char *			ReadIniStr( char *pszIniFile, char *pszKey, char *pszDefault );
bool			WriteIniFile( void );
bool			Init( void );
void			DrawPic( HWND hWnd, int iPicWidth, int iPicHeight, char *pOrigBitmap, BITMAPINFO *pbmi, char *pBitmap, int iDeg );
BOOL CALLBACK		EnumWindowsProc(  HWND hWnd, LPARAM lParam );
int			SetFont( LOGFONT *plf );
int			show_timer_dlg( void );
LRESULT			CALLBACK wndproc_timer_dlg( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam );
void			fix_num_suffix( char *pdest, __int64 val, int digits );

char		gaversion[] = "1.02";
HINSTANCE	ghinstance;				// application's instance handle
HWND		ghwnd = NULL;				// handle of main dialog
HWND		ghwndtxt = NULL;			// handle of static control
HWND		ghtooltip = NULL;
HWND		ghwndtimer = NULL;			// handle of timer dialog
bool		fTimerIDUpdateActive = false;
bool		fTimerIDScrollActive = false;
char		gainifile[261];				// inifile's path and name
HMENU		ghmenu;					// global right-click menu
bool		gfaboutactive = false;			// true if about dlgbox is shown
char		gatooltiptext[256];			// buffer for tooltip text
__int64		gnrcvavg = 0;
__int64		gnrcvtot = 0;
__int64		gnsndavg = 0;
__int64		gnsndtot = 0;

// config
int			giCfgTop;
int			giCfgLeft;
char *			gpCfgFontName = "Microsoft Sans Serif";
int			giCfgFontSize = 11;
int			giCfgFontWeight = 400;
int			giCfgFontItalic = 0;
int			giCfgWindowSnap = 20;
int			giCfgScrollDelay = 0;
int			giCfgToolTip = 1;
int			giCfgUpdateInterval = 2000;
int			giCfgRateInertia = 9;
__int64			giCfgRcvAllTimeTotal = 0;
__int64			giCfgSndAllTimeTotal = 0;
char *			gpCfgNICName = "";
int			giCfgWindowFrame = 0;
int			giCfgUseColors = 1;
unsigned int		guCfgBkgColor = 0x3dbae8;	// bbggrr format
unsigned int		guCfgTxtColor = 0x202020;	// bbggrr format

//
// WinMain
//
int WINAPI WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	MSG		msg;

	ghinstance = hInstance;

	if( !Init() ) {
		MessageBox( NULL, "Initialization error, exiting...", "Watshit", MB_OK | MB_ICONEXCLAMATION );
		return 1;
	}

	while( TRUE ) {
		if( PeekMessage( &msg, NULL, 0, 0, PM_NOREMOVE ) ) {
			if( !GetMessage( &msg, NULL, 0, 0 ) ) {
				break;
			}
			if( !IsDialogMessage( ghwndtimer, &msg ) ) {
				TranslateMessage( &msg );
				DispatchMessage( &msg );
			}
		} else {
			WaitMessage();
		}
	}

	WriteIniFile();

	return msg.wParam;
}

int SetFont( LOGFONT *plf )
{
	HFONT	hf;
	HDC	hdc;
	SIZE	s;
	char	atxt[] = "DL: 88.8 KB/s, UL: 88.8 KB/s";

	if( !( hf = CreateFontIndirect( plf ) ) ) {
		MessageBox( NULL, "Error", "Ack, couldn't create the selected font!", MB_OK );
		return 0;
	}
	SendMessage( GetDlgItem( ghwnd, IDC_LTIME), WM_SETFONT, (WPARAM) hf, 1 );


	SendMessage( ghwnd, WM_SETFONT, (WPARAM) hf, 1 );


	memset( &s, 0, sizeof( s ) );
	hdc = GetDC( ghwndtxt );
	SelectObject( hdc, hf );
	GetTextExtentPoint32( hdc, atxt, sizeof( atxt ), &s );
	if( giCfgWindowFrame ) {
		s.cx += 4;
		s.cy += 2;
	} else {
		s.cx += 1;
	}
	ReleaseDC( ghwndtxt, hdc );

	free( gpCfgFontName );
	gpCfgFontName = _strdup( plf->lfFaceName );
	giCfgFontSize = abs( plf->lfHeight );
	giCfgFontWeight = abs( plf->lfWeight );
	giCfgFontItalic = abs( plf->lfItalic );

	SetWindowPos( ghwnd,
		NULL, 0, 0, s.cx, s.cy, SWP_NOMOVE | SWP_NOZORDER );
	SetWindowPos( GetDlgItem( ghwnd, IDC_LTIME),
		NULL, 0, 0, s.cx, s.cy, SWP_NOMOVE | SWP_NOZORDER );
	return 0;
}

unsigned int char_hex_to_uint( char c )
{
	if( c >= '0' && c <= '9' ) {
		return c - '0';
	} else if( c >= 'A' && c <= 'F' ) {
		return c - 'A' + 10;
	} else if( c >= 'a' && c <= 'f' ) {
		return c - 'a' + 10;
	}

	return 0;
}

unsigned int text_rgb_to_uint_bgr( char *prgb )
{
	return ( ( ( char_hex_to_uint( prgb[0] ) << 4 ) + char_hex_to_uint( prgb[1] ) ) ) + 
	       ( ( ( char_hex_to_uint( prgb[2] ) << 4 ) + char_hex_to_uint( prgb[3] ) ) << 8 ) + 
	       ( ( ( char_hex_to_uint( prgb[4] ) << 4 ) + char_hex_to_uint( prgb[5] ) ) << 16 );
}

char uint_to_char_hex( unsigned int u )
{
	if( u < 10 ) {
		return '0' + u;
	} else if( u < 16 ) {
		return 'A' + u - 10;
	}

	return '0';
}

void uint_bgr_to_text_rgb( unsigned int ubgr, char *prgb )
{
	prgb[0] = uint_to_char_hex( ( ubgr >> 4 ) & 0x0f );
	prgb[1] = uint_to_char_hex( ( ubgr >> 0 ) & 0x0f );
	prgb[2] = uint_to_char_hex( ( ubgr >> 12 ) & 0x0f );
	prgb[3] = uint_to_char_hex( ( ubgr >> 8 ) & 0x0f );
	prgb[4] = uint_to_char_hex( ( ubgr >> 20 ) & 0x0f );
	prgb[5] = uint_to_char_hex( ( ubgr >> 16 ) & 0x0f );
	prgb[6] = 0;
}

UINT CALLBACK CFHookProc( HWND hwnd, UINT umsg, WPARAM wparam, LPARAM lparam )
{
	LOGFONT	lf;

	switch( umsg ) {
	case WM_COMMAND:
		if( wparam == 1026 ) {	// How the _hell_ am I supposed to know this?
			SendMessage( hwnd, WM_CHOOSEFONT_GETLOGFONT, NULL, (LPARAM) &lf );
			SetFont( &lf );
			return 0;
		}
	}

	return 0;
}

// Handles all WM_NOTIFY msgs
int handle_wm_notify( HWND hwnd, WPARAM wparam, LPARAM lparam )
{
	LPNMTTDISPINFO	p;
	char		at1[64];
	char		at2[64];
	char		at3[64];
	char		at4[64];

	if( ((LPNMHDR) lparam)->code == TTN_NEEDTEXT ) {
		p = (LPNMTTDISPINFO) lparam;

		fix_num_suffix( at1, gnrcvtot, 4 );
		fix_num_suffix( at2, gnsndtot, 4 );
		fix_num_suffix( at3, giCfgRcvAllTimeTotal, 4 );
		fix_num_suffix( at4, giCfgSndAllTimeTotal, 4 );
		sprintf( gatooltiptext, "Total DL: %sB (%sB), UL: %sB (%sB)", at1, at3, at2, at4 );

		p->hinst = NULL;
		p->lpszText = gatooltiptext;
		SetWindowPos( ghwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE );
	}

	return 0;
}

void fix_num_suffix( char *pdest, __int64 val, int digits )
{
	int	n = 0;
	__int64	nfrac;
	char	asuf[] = "KMGTPEZY";

	do {
		nfrac = val;
		val = val / 1024;
		nfrac = nfrac - val * 1024;
		n++;
	} while( val > 999 );

	sprintf( pdest, "%d.%3.3d", (int) val, (int) ( nfrac * 1000 / 1024 ) );
	pdest += min( digits - ( pdest[digits - 1] == '.' ), (int) strlen( pdest ) );
	*pdest++ = ' ';

	if( n <= sizeof( asuf ) ) {
		*pdest++ = asuf[n - 1];
	} else {
		*pdest++ = '_';
	}
	*pdest = 0;
}

int get_perfdata( unsigned int *prcvdat, unsigned int *psnddat )
{
	static unsigned long	perfsize = 8192;
	static PPERF_DATA_BLOCK	pperf = (PPERF_DATA_BLOCK) malloc( perfsize );
	PERF_OBJECT_TYPE *	ppot;
	PERF_COUNTER_DEFINITION*ppcd;
	PERF_COUNTER_DEFINITION*ppcdrcv = NULL;
	PERF_COUNTER_DEFINITION*ppcdsnd = NULL;
	unsigned char *		p;
	unsigned int		n;
	char			a[256];

	while( ( n = RegQueryValueEx( HKEY_PERFORMANCE_DATA, "510", NULL, NULL, (unsigned char *) pperf, &perfsize ) ) == ERROR_MORE_DATA ) {
		perfsize += 8192;
		pperf = (PPERF_DATA_BLOCK) realloc( pperf, perfsize );
	}
	if( n != ERROR_SUCCESS ) {
		return 0;
	}
	p = (unsigned char *)pperf + pperf->HeaderLength;
	for( n = 0; n < pperf->NumObjectTypes && ((PERF_OBJECT_TYPE *)p)->ObjectNameTitleIndex != 510; n++ ) {
		p += ((PERF_OBJECT_TYPE *)p)->TotalByteLength;
	}
	ppot = (PERF_OBJECT_TYPE *) p;
	p += ppot->DefinitionLength;
	if( ppot->NumInstances != -1 ) {
		for( n = 1; (int)n < ppot->NumInstances; n++ ) {
			WideCharToMultiByte( CP_ACP, 0, (unsigned short *) (p + ((PERF_INSTANCE_DEFINITION *)p)->NameOffset), 
				wcslen( (unsigned short *) (p + ((PERF_INSTANCE_DEFINITION *)p)->NameOffset) ) + 1,
				a, 256, NULL, NULL );
			p += ((PERF_INSTANCE_DEFINITION *)p)->ByteLength;
			if( !*gpCfgNICName || !_stricmp( a, gpCfgNICName ) ) {
				break;
			}
			p += ((PERF_COUNTER_BLOCK *)p)->ByteLength;
		}
	}
	ppcd = (PERF_COUNTER_DEFINITION *) ( (char *)ppot + ppot->HeaderLength );
	for( n = 0; n < ppot->NumCounters && ( !ppcdrcv || !ppcdsnd ); n++ ) {
		switch( ppcd->CounterNameTitleIndex ) {
		case 264:
			ppcdrcv = ppcd;
			break;
		case 506:
			ppcdsnd = ppcd;
			break;
		}
		ppcd = (PERF_COUNTER_DEFINITION *) ( (char *)ppcd + ppcd->ByteLength );
	}
	if( ppcdrcv ) {
		*prcvdat = *( (unsigned int *) ( p + ppcdrcv->CounterOffset ) );
	}
	if( ppcdsnd ) {
		*psnddat = *( (unsigned int *) ( p + ppcdsnd->CounterOffset ) );
	}

	if( !ppcdrcv && !ppcdsnd ) {
		return 0;
	}

	return 1;
}

//
// Handle msgs for IDD_MAIN
//
LRESULT CALLBACK WindowProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	RECT			rWnd;
	int			iWidth;
	int			iHeight;
	static int		iXOff;
	static int		iYOff;
	char			atxt[256];
	char			at1[64];
	char			at2[64];
	static int		inside = 0;
	static unsigned int	nrcvolddat = -1;
	static unsigned int	nsndolddat = -1;
	unsigned int		nrcvdat, nsnddat;
	unsigned int		ticks;
	static unsigned int	oldticks = 0;

	switch( msg ) {
	case WM_DESTROY:
		PostQuitMessage( 0 );
		return 0;

	case WM_ENDSESSION:
		if( wParam ) {
			ReleaseTimer();
			ReleaseCapture();
			WriteIniFile();
		}
		return 0;

	case WM_TIMER:
		if( wParam == ID_TIMER_UPDATE ) {
			if( inside ) {
				return false;
			}
			inside = 1;
			ticks = GetTickCount();
			if( nrcvolddat == -1 ) {
				if( !get_perfdata( &nrcvolddat, &nsndolddat ) ) {
					nrcvolddat = -1;
				}
			}
			if( !get_perfdata( &nrcvdat, &nsnddat ) ) {
				nrcvdat = 0;
				nsnddat = 0;
			}

			nrcvdat -= nrcvolddat;
			nsnddat -= nsndolddat;

			gnrcvtot += nrcvdat;
			giCfgRcvAllTimeTotal += nrcvdat;
			gnrcvavg = (__int64) ( gnrcvavg * giCfgRateInertia + nrcvdat * ( 1000.0f / ( ticks - oldticks ) ) ) / ( giCfgRateInertia + 1 );
			//gnrcvavg = nrcvdat * 1000 / ( ticks - oldticks );

			gnsndtot += nsnddat;
			giCfgSndAllTimeTotal += nsnddat;
			gnsndavg = (__int64) ( gnsndavg * giCfgRateInertia + nsnddat * ( 1000.0f / ( ticks - oldticks ) ) ) / ( giCfgRateInertia + 1 );
			//gnsndavg = nsnddat * 1000 / ( ticks - oldticks );

			fix_num_suffix( at1, gnrcvavg, 4 );
			fix_num_suffix( at2, gnsndavg, 4 );
			sprintf( atxt, "DL: %sB/s, UL: %sB/s     ", at1, at2 );
			//sprintf( atxt, "%d %d", nrcvdat, nsnddat );
			//sprintf( atxt, "0x%X 0x%X", nrcvdat, nsnddat );
			SetDlgItemText( ghwnd, IDC_LTIME, atxt );

			//SetWindowPos( ghwnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE | SWP_NOACTIVATE );
			oldticks = ticks;
			nrcvolddat += nrcvdat;
			nsndolddat += nsnddat;
			inside = 0;
			return false;
		} else if( wParam == ID_TIMER_SCROLL ) {
			char szText[128];

			GetDlgItemText( ghwnd, IDC_LTIME, szText, 128 );
			if( strlen( szText ) > 5 ) {	// > strlen( "03:03")
				SetDlgItemText( ghwnd, IDC_LTIME, szText + 1 );
			} else {
				KillTimer( ghwnd, wParam );
				fTimerIDScrollActive = false;
				fTimerIDUpdateActive = true;
			}
			return false;
		}
		return false;

	case WM_RBUTTONDOWN:
		if( !gfaboutactive ) {
			TrackPopupMenu( ghmenu, TPM_LEFTALIGN | TPM_RIGHTBUTTON, 
				LOWORD( GetMessagePos() ), HIWORD( GetMessagePos() ), 
				0, hWnd, NULL );
		}
		return false;

	case WM_LBUTTONDOWN:
		SetCapture( hWnd );
		iXOff = LOWORD( lParam );
		iYOff = HIWORD( lParam );
		return false;

	case WM_MOUSEMOVE:
		if( wParam & MK_LBUTTON ) {
			GetWindowRect( hWnd, &rWnd );
			iWidth = rWnd.right - rWnd.left;
			iHeight = rWnd.bottom - rWnd.top;
			giCfgLeft = LOWORD( GetMessagePos() ) - iXOff;
			giCfgTop = HIWORD( GetMessagePos() ) - iYOff;
			if( ( LOWORD( lParam ) >= 0 ) && ( HIWORD( lParam ) >= 0 ) &&
			    ( LOWORD( lParam ) <= iWidth ) && ( HIWORD( lParam ) <= iHeight ) ) {
				giCfgLeft = rWnd.left + LOWORD( lParam ) - iXOff;
				giCfgTop = rWnd.top + HIWORD( lParam ) - iYOff;
			}
			EnumWindows( EnumWindowsProc, ( iHeight << 16 ) + iWidth );

			MoveWindow( hWnd, giCfgLeft, giCfgTop, iWidth, iHeight, true );
		} else {
			if( fTimerIDScrollActive || !giCfgScrollDelay ) {
				return false;
			}
			fTimerIDScrollActive = true;

			if( !SetTimer( hWnd, ID_TIMER_SCROLL, giCfgScrollDelay, NULL ) ) {
				MessageBox( NULL, "Couldn't setup timer!", "Error!", MB_OK );
				EndDialog( hWnd, false );
				return false;
			}
		}
		return false;

	case WM_LBUTTONUP:
		ReleaseCapture();
		return false;

	case WM_NOTIFY:
		handle_wm_notify( hWnd, wParam, lParam );
		return 0;

	case WM_CTLCOLORSTATIC:
		if( giCfgUseColors && (HWND) lParam == ghwndtxt ) {
			SetBkColor( (HDC) wParam, guCfgBkgColor );
			SetTextColor( (HDC) wParam, guCfgTxtColor );
			return (long) GetStockObject( LTGRAY_BRUSH );
		}
		return 0;

	case WM_COMMAND:
		switch( wParam ) {
		case ID_MAIN_ABOUT:
			sprintf( atxt, "Watshit v%s", gaversion );
			MessageBox( NULL, "Coded by Mikael Klasson\nfluff@geocities.com\nhttp://mklasson.cjb.net", atxt, MB_OK );
			return false;

		case ID_MAIN_FONT:
			CHOOSEFONT	cf;
			LOGFONT		lf;
			memset( &lf, 0, sizeof( lf ) );
			memset( &cf, 0, sizeof( cf ) );
			cf.lStructSize = sizeof( cf );
			cf.Flags = CF_BOTH | CF_APPLY | CF_ENABLEHOOK;
			cf.lpfnHook = CFHookProc;
			cf.lpLogFont = &lf;
			if( ChooseFont( &cf ) ) {
				SetFont( &lf );
			}
			return 0;

		case ID_MAIN_QUIT:
		case IDCANCEL:
			ReleaseTimer();
			ReleaseCapture();
			PostQuitMessage( 0 );
			return false;
		}
		return false;
	}

	return DefWindowProc( hWnd, msg, wParam, lParam );
}

//
// decode RLE data
// returns:	ptr to unpacked data
//		NULL if error
//
char *unpack( unsigned char *pin )
{
	int	ncnt;
	int	nchr;
	int	n;
	int	nmaxburstlen;
	char *	pout;
	char *	ppic;

	if( !( pout = (char *) malloc( *( (unsigned int *)pin ) ) ) ) {
		return NULL;
	}
	ppic = pout;
	nmaxburstlen = *( pin + 4 );
	pin += 4 + 1;

	while( ( ncnt = (int) *pin++ ) ) {
		if( ncnt < 256 - nmaxburstlen ) {
			nchr = *pin++;
			for( n = 0; n < ncnt; n++ ) {
				*pout++ = nchr;
			}
		} else {
			ncnt -= 255 - nmaxburstlen;
			memcpy( pout, pin, ncnt );
			pin += ncnt;
			pout += ncnt;
		}
	}

	return ppic;
}

//
// ReleaseTimer
//
void ReleaseTimer( void )
{
	fTimerIDUpdateActive = false;
	KillTimer( ghwnd, ID_TIMER_UPDATE );
	fTimerIDScrollActive = false;
	KillTimer( ghwnd, ID_TIMER_SCROLL );
}

//
// ReadIniFile
//
void ReadIniFile( void )
{
	char	a[7];
	char *	p;

	giCfgTop = (int) ReadIniVal( gainifile, "top", CFGTOP_ERR );
	giCfgLeft = (int) ReadIniVal( gainifile, "left", CFGLEFT_ERR );
	gpCfgFontName = ReadIniStr( gainifile, "font_name", gpCfgFontName );
	giCfgFontSize = (int) ReadIniVal( gainifile, "font_size", giCfgFontSize );
	giCfgFontWeight = (int) ReadIniVal( gainifile, "font_weight", giCfgFontWeight );
	giCfgFontItalic = (int) ReadIniVal( gainifile, "font_italic", giCfgFontItalic );
	giCfgWindowSnap = (int) ReadIniVal( gainifile, "window_snap", giCfgWindowSnap );
	giCfgScrollDelay = (int) ReadIniVal( gainifile, "scroll_delay", giCfgScrollDelay );
	giCfgToolTip = (int) ReadIniVal( gainifile, "tooltip", giCfgToolTip );
	giCfgWindowFrame = (int) ReadIniVal( gainifile, "windowframe", giCfgWindowFrame );
	giCfgUpdateInterval = (int) ReadIniVal( gainifile, "update_interval", giCfgUpdateInterval );
	giCfgRateInertia = (int) ReadIniVal( gainifile, "rate_inertia", giCfgRateInertia );
	giCfgRcvAllTimeTotal = 1024 * ReadIniVal( gainifile, "rcv_alltimetotal", giCfgRcvAllTimeTotal );
	giCfgSndAllTimeTotal = 1024 * ReadIniVal( gainifile, "snd_alltimetotal", giCfgSndAllTimeTotal );
	gpCfgNICName = ReadIniStr( gainifile, "nic_name", gpCfgNICName );

	giCfgUseColors = (int) ReadIniVal( gainifile, "use_colors", giCfgUseColors );

	uint_bgr_to_text_rgb( guCfgBkgColor, a );
	p = ReadIniStr( gainifile, "background_color", a );
	guCfgBkgColor = text_rgb_to_uint_bgr( p );

	uint_bgr_to_text_rgb( guCfgTxtColor, a );
	p = ReadIniStr( gainifile, "text_color", a );
	guCfgTxtColor = text_rgb_to_uint_bgr( p );

	return;
}

//
// ReadIniVal
//
__int64 ReadIniVal( char *pszIniFile, char *pszKey, __int64 iDefault )
{
	FILE	*in;
	char	szLine[81];
	int	iKeyLen;
	char	*psVal;
	__int64	iVal = iDefault;

	if( !( in = fopen( pszIniFile, "rt" ) ) ) {
		return iVal;
	}

	do {
		fgets( szLine, 80, in );
		if( ( psVal = strchr( szLine, '=' ) ) ) {
			iKeyLen = psVal - szLine;
			if( !_strnicmp( szLine, pszKey, iKeyLen ) ) {
				iVal = _atoi64( psVal + 1 );
				break;
			}
		}
	} while( !feof( in ) );

	fclose( in );

	return iVal;
}

//
// ReadIniStr
//
char *ReadIniStr( char *pszIniFile, char *pszKey, char *pszDefault )
{
	FILE	*in;
	char	szLine[81];
	int	iKeyLen;
	char	*psVal;
	char	*pszStr = pszDefault;

	if( !( in = fopen( pszIniFile, "rt" ) ) ) {
		return pszDefault;
	}

	do {
		fgets( szLine, 80, in );
		if( ( psVal = strchr( szLine, '=' ) ) ) {
			iKeyLen = psVal - szLine;
			if( !_strnicmp( szLine, pszKey, iKeyLen ) ) {
				pszStr = _strdup( psVal + 1 );
				if( *(pszStr + strlen( pszStr ) - 1 ) == '\n' ) {
					*(pszStr + strlen( pszStr ) - 1 ) = '\0';
				}
				break;
			}
		}
	} while( !feof( in ) );

	fclose( in );

	return pszStr;
}

void write_int64( FILE *out, __int64 n )
{
	if( !n ) {
		fputc( '0', out );
	} else {
		if( n / 10 ) {
			write_int64( out, n / 10 );
		}
		fputc( '0' + (int) ( n % 10 ), out );
	}
}

//
// WriteIniFile
//
bool WriteIniFile( void )
{
	FILE	*out;
	char	a[7];

	if( !( out = fopen( gainifile, "wt" ) ) ) {
		return false;
	}

	fprintf( out, "[Watshit]\n" );
	fprintf( out, "version=%s\n", gaversion );
	fprintf( out, "top=%d\n", giCfgTop );
	fprintf( out, "left=%d\n\n", giCfgLeft );

	fprintf( out, "font_name=%s\n", gpCfgFontName );
	fprintf( out, "font_size=%d\n", giCfgFontSize );
	fprintf( out, "font_weight=%d\n", giCfgFontWeight );
	fprintf( out, "font_italic=%d\n\n", giCfgFontItalic );

	fprintf( out, "; snap sensitivity; 0 to disable window snapping\n" );
	fprintf( out, "window_snap=%d\n\n", giCfgWindowSnap );

	fprintf( out, "; scroll delay; 0 to disable scrolling\n" );
	fprintf( out, "scroll_delay=%d\n\n", giCfgScrollDelay );

	fprintf( out, "; display info on totals in a tooltip? 0 to disable\n" );
	fprintf( out, "tooltip=%d\n\n", giCfgToolTip );

	fprintf( out, "; draw a frame around the window? 0 or 1\n" );
	fprintf( out, "windowframe=%d\n\n", giCfgWindowFrame );

	fprintf( out, "; use the custom colors specified below? 0 or 1\n" );
	fprintf( out, "use_colors=%d\n\n", giCfgUseColors );

	uint_bgr_to_text_rgb( guCfgBkgColor, a );
	fprintf( out, "; background color in hex RRGGBB format, e.g. ffff00 for yellow\n" );
	fprintf( out, "background_color=%s\n\n", a );

	uint_bgr_to_text_rgb( guCfgTxtColor, a );
	fprintf( out, "; text color in hex RRGGBB format, e.g. ff00ff for purple\n" );
	fprintf( out, "text_color=%s\n\n", a );

	fprintf( out, "; interval between updates in ms\n" );
	fprintf( out, "update_interval=%d\n\n", giCfgUpdateInterval );

	fprintf( out, "; bias to old rate values; higher values make the rates adapt more slowly to change\n" );
	fprintf( out, "; a value of 0 uses only the new measurements\n" );
	fprintf( out, "rate_inertia=%d\n\n", giCfgRateInertia );

	fprintf( out, "; look this up in NT's performance monitor (use the instance name)\n" );
	fprintf( out, "; or leave empty to use first one detected\n" );
	fprintf( out, "nic_name=%s\n\n", gpCfgNICName );

	fprintf( out, "; total Kbytes received\n" );
	fprintf( out, "rcv_alltimetotal=" );
	write_int64( out, giCfgRcvAllTimeTotal / 1024 );
	fprintf( out, "\n\n" );

	fprintf( out, "; total Kbytes sent\n" );
	fprintf( out, "snd_alltimetotal=" );
	write_int64( out, giCfgSndAllTimeTotal / 1024 );
	fprintf( out, "\n\n" );

	fclose( out );

	return true;
}

//
// Init
//
bool Init( void )
{
	WNDCLASS	wc;
	RECT		rWnd;
	int		iWidth;
	int		iHeight;
	static int	iXOff;
	static int	iYOff;
	LOGFONT		lf;
	TOOLINFO	ti;

	_getcwd( gainifile, 260 );
	strcat( gainifile, "\\watshit.ini" );

	ReadIniFile();

	// insert a "Timers" popup menu in the main menu
	ghmenu = GetSubMenu( LoadMenu( ghinstance, MAKEINTRESOURCE( IDR_MMAIN ) ), 0 );

	memset( &wc, 0, sizeof( wc ) );
	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = WindowProc;
	wc.hInstance = ghinstance;
	wc.hIcon = NULL;
	wc.hCursor = LoadCursor( NULL, IDC_ARROW );
	wc.hbrBackground = (HBRUSH) COLOR_WINDOW;
	wc.lpszClassName = "Watshit";
	wc.lpszMenuName = NULL;
	if( !RegisterClass( &wc ) ) {
		MessageBox( NULL, "RegisterClass() failed!", "Watshit", MB_OK );
		return 0;
	}

	if( !( ghwnd = CreateWindowEx( WS_EX_TOOLWINDOW | WS_EX_TOPMOST, "Watshit", "Watshit",
			WS_POPUP | ( giCfgWindowFrame ? WS_BORDER : 0 ),
			200, 
			200,
			80, 
			20,
			NULL,
			NULL,
			ghinstance,
			NULL ) ) ) {
		MessageBox( NULL, "CreateWindow( ghwnd ) failed!", "Watshit", MB_OK );
		return 0;
	}

	if( !( ghwndtxt = CreateWindowEx( 0, "STATIC", "", 
			WS_VISIBLE | WS_CHILD | SS_LEFTNOWORDWRAP,
			//WS_VISIBLE | WS_CHILD | SS_CENTER,
			0, 0, 0, 0,
			ghwnd,
			(HMENU) IDC_LTIME,
			ghinstance,
			NULL ) ) ) {
		MessageBox( NULL, "CreateWindow( ghwndtxt ) failed!", "Watshit", MB_OK );
		return 0;
	}

	fTimerIDUpdateActive = true;
	
	if( giCfgLeft != CFGLEFT_ERR && giCfgTop != CFGTOP_ERR ) {
		GetWindowRect( ghwnd, &rWnd );
		iWidth = rWnd.right - rWnd.left;
		iHeight = rWnd.bottom - rWnd.top;
		MoveWindow( ghwnd, giCfgLeft, giCfgTop, iWidth, iHeight, true );
	}

	if( !SetTimer( ghwnd, ID_TIMER_UPDATE, giCfgUpdateInterval, NULL ) ) {
		MessageBox( NULL, "Couldn't setup timer!", "Error!", MB_OK );
		return 0;
	}

	ShowWindow( ghwnd, SW_SHOW );
	UpdateWindow( ghwnd );

	memset( &lf, 0, sizeof( lf ) );
	lf.lfHeight = -giCfgFontSize;
	lf.lfWeight = giCfgFontWeight;
	lf.lfItalic = giCfgFontItalic;
	_snprintf( lf.lfFaceName, LF_FACESIZE, "%s", gpCfgFontName );
	SetFont( &lf );

	if( giCfgToolTip ) {
		INITCOMMONCONTROLSEX	icc;
		memset( &icc, 0, sizeof( icc ) );
		icc.dwSize = sizeof( icc );
		icc.dwICC = ICC_BAR_CLASSES;
		if( !InitCommonControlsEx( &icc ) ) {
			MessageBox( NULL, "InitCommonControlsEx() failed!", "Error", MB_OK );
			return 0;
		}

		if( !( ghtooltip = CreateWindowEx( 0, TOOLTIPS_CLASS, "", 
				TTS_ALWAYSTIP,
				CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT,
				ghwnd,
				NULL,
				ghinstance,
				NULL ) ) ) {
			return 0;
		}

		memset( &ti, 0, sizeof( ti ) );
		ti.cbSize = sizeof( ti );
		ti.uFlags = TTF_IDISHWND | TTF_SUBCLASS;
		ti.hwnd = ghwnd;
		ti.uId = (unsigned int) ghwnd;
		ti.hinst = ghinstance;
		ti.lpszText = LPSTR_TEXTCALLBACK;
		ti.lParam = 0;
		SendMessage( ghtooltip, TTM_ADDTOOL, 0, (LPARAM) &ti );
	}

	return 1;
}

BOOL CALLBACK EnumWindowsProc(  HWND hWnd, LPARAM lParam )
{
	RECT	rWnd;
	int	iTop, iLeft;
	int	iWidth, iHeight;
	BOOL	bTopChanged = false;
	BOOL	bLeftChanged = false;

	if( !giCfgWindowSnap ) {
		return true;
	}

	if( !IsWindowVisible( hWnd ) ) {
		return true;
	}

	iWidth = LOWORD( lParam );
	iHeight = HIWORD( lParam );

	if( ghwnd != hWnd ) {
		GetWindowRect( hWnd, &rWnd );

		if( abs( rWnd.top - giCfgTop ) < giCfgWindowSnap ) {
			iTop = rWnd.top;
			bTopChanged = true;

			if( abs( rWnd.left - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.left;
				bLeftChanged = true;
			}

			if( abs( rWnd.left - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.left - iWidth;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.right;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.right - iWidth;
				bLeftChanged = true;
			}
		}

		if( abs( rWnd.bottom - giCfgTop ) < giCfgWindowSnap ) {
			iTop = rWnd.bottom;
			bTopChanged = true;

			if( abs( rWnd.left - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.left;
				bLeftChanged = true;
			}

			if( abs( rWnd.left - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.left - iWidth;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.right;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.right - iWidth;
				bLeftChanged = true;
			}
		}

		if( abs( rWnd.top - ( giCfgTop + iHeight ) ) < giCfgWindowSnap ) {
			iTop = rWnd.top - iHeight;
			bTopChanged = true;

			if( abs( rWnd.left - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.left;
				bLeftChanged = true;
			}

			if( abs( rWnd.left - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.left - iWidth;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.right;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.right - iWidth;
				bLeftChanged = true;
			}
		}

		if( abs( rWnd.bottom - ( giCfgTop + iHeight ) ) < giCfgWindowSnap ) {
			iTop = rWnd.bottom - iHeight;
			bTopChanged = true;

			if( abs( rWnd.left - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.left;
				bLeftChanged = true;
			}

			if( abs( rWnd.left - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.left - iWidth;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - giCfgLeft ) < giCfgWindowSnap ) {
				iLeft = rWnd.right;
				bLeftChanged = true;
			}

			if( abs( rWnd.right - ( giCfgLeft + iWidth ) ) < giCfgWindowSnap ) {
				iLeft = rWnd.right - iWidth;
				bLeftChanged = true;
			}
		}

		if( bTopChanged && bLeftChanged ) {
			giCfgTop = iTop;
			giCfgLeft = iLeft;
			return false;
		}
	}

	return true;
}
